const shelljs = require('shelljs');
const util = require('../util');
const chalk = require('chalk');
const debug = require('debug')('cmd:dev')
const path = require('path');
const config = JSON.parse(process.env.config);
const WHITE_LIST = config.WHITE_LIST;
const brandName = config.brandName;


module.exports = function(client) {
  client
  .registryCommand('dev <cmd>')
  .description(chalk.bold.blue('system cmd: link or unlink plugin'))
  .action((cmd) => {
    const pluginName = this.rootGeneratorName();
    
    debug('pluginame, %s', pluginName);
    if (cmd !== 'unlink' && cmd !== 'link') {
      return;
    }
    
    if (util.isPluginName(pluginName)) {
      if (this.pluginIsExist(pluginName)) {
        this.log.error('plugin is exist')
      } else {
        if (cmd === 'link') {
          this.fs.copy(path.resolve(__dirname, '../generator/clientrc/clientrc'), path.resolve(process.cwd(), `.${brandName}rc`))
          this.log(`.${brandName}rc file created, please ${chalk.yellow(`${config.clientName} --help`)}`);
        } else if (cmd === 'unlink') {
          this.log('please remove plugin on' + `${chalk.yellow(` '.${brandName}rc' `)}` + ' file');
        }
        
      }
      
    } else {
      // @ali/client-plugin-xx or client-plugin-xx
      this.log.error(`plugin name ${pluginName} is illegal, example: ${brandName}-plugin-xx, ${WHITE_LIST.map(prefix => prefix + '/' + brandName + '-plugin-xx').join(', ')}`)
    }
  });
} 