const client = require('../../core');
const config = JSON.parse(process.env.config);
const brandName = config.brandName;

module.exports = [
  {
    type: 'input',
    name: 'name',
    message: "What's your plugin name",
    validate: function(value) {
      if (client.pluginIsExist(value)) {
        client.log.error(`${value} is registried`);
        return false
      } else if (!client.isPluginName(value)) {
        client.log.error(`${value} is invalid`);
        return `please enter a valid plugin name, ${brandName}-plugin-xxx`
      } else {
        return true;
      }
    }
  }, 
  {
    type: 'input',
    name: 'command',
    message: "What's your command name of plugin",
    validate: function(value) {
      if (!value) {
        return 'please enter command of plugin'
      } else if(client.hasCommand(value) ) {
        client.log.error(`${value} is registried`);
        return 'please enter a new command'
      } else {
        return true
      }
    }
  }, 
  {
    type: 'input',
    name: 'description',
    message: "What's description of plugin",
    validate: function(value) {
      if (!value) {
        return 'please enter description of plugin'
      } else {
        return true
      }
      
    }
  }, 
  {
    type: 'list',
    name: 'registry',
    message: 'Which registry do you want ?',
    choices: [
      'npm',
      'tnpm'
    ]
  },
  {
    type: 'list',
    name: 'template',
    message: 'Which template do you want ?',
    choices: [
      'plugin',
      'scaffold',
      {
        name: 'other',
        disabled: 'Unavailable at this time'
      }
    ]
  }
]