/**
 * ----------------------------------
 * @file add.js
 * @desc 拉取特定的插件
 * @author Matrix <fangbo.fb@alibaba-inc.com>
 * @create: 2018/6
 * ----------------------------------
 */
const shelljs = require('shelljs');
const util = require('../util');
const chalk = require('chalk');
const debug = require('debug')('cmd:install')
const config = JSON.parse(process.env.config);
const WHITE_LIST = config.WHITE_LIST;
const brandName = config.brandName;

module.exports = function(client) {
  client
  .registryCommand('install [plugin]')
  .alias('i')
  .option('-g, --global', 'Intall global module')
  .description(chalk.bold.blue('system cmd: install plugin with global director'))
  .action((plugin, cmd) => {
    debug(`${config.npmClient} i ${plugin} -g`)
    
    if (util.isPluginName(plugin)) {
      if (cmd['global']) {
        shelljs.exec(`${config.npmClient} i ${plugin} -g`);
      } else {
        shelljs.exec(`${config.npmClient} i ${plugin}`);
      }
    } else {
      this.log.error(`plugin name ${plugin} is illegal, example: ${brandName}-plugin-xx, ${WHITE_LIST.map(prefix => prefix + '/' + brandName + '-plugin-xx').join(', ')}`)
    }
  });
} 