const chalk = require('chalk');
const stripAnsi = require('strip-ansi');
const cliBoxes = require('cli-boxes');
const pad = require('pad-component');
const border = cliBoxes.round;
const COLOR_MAP = ['white', 'red', 'red', 'yellow']

module.exports = (message, maxLength = 25) => {
  message = (message || 'Welcome to hellosay, ladies and gentlemen!').trim();
  const borderHorizontal = border.horizontal.repeat(maxLength);

  const frame = {
    top: border.topLeft + borderHorizontal + border.topRight,
    side: border.vertical,
    bottom:border.bottomLeft + borderHorizontal + border.bottomRight
  };

  const messageList = message.split('\n');

  return `
  ${frame.top}
${messageList.map((msg = '', index) => {
  if (index === 0) {
    return `  ${frame.side}${chalk[COLOR_MAP[index]](pad(msg, maxLength).slice(1))}${frame.side}`
  }
  return `  ${frame.side}${chalk[COLOR_MAP[index]](pad(msg, maxLength))}${frame.side}`
}).join('\n')}
  ${frame.bottom}
`
}